//
// Copyright(C) 1993-1996 Id Software, Inc.
// Copyright(C) 1993-2008 Raven Software
// Copyright(C) 2005-2014 Simon Howard
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//

#include "doomtype.h"
#include "sounds.h"

musicinfo_t heretic_S_music[] = {
    { 0 },
    { "MUS_E1M1", 0 }, // 1-1
    { "MUS_E1M2", 0 },
    { "MUS_E1M3", 0 },
    { "MUS_E1M4", 0 },
    { "MUS_E1M5", 0 },
    { "MUS_E1M6", 0 },
    { "MUS_E1M7", 0 },
    { "MUS_E1M8", 0 },
    { "MUS_E1M9", 0 },

    { "MUS_E2M1", 0 }, // 2-1
    { "MUS_E2M2", 0 },
    { "MUS_E2M3", 0 },
    { "MUS_E2M4", 0 },
    { "MUS_E1M4", 0 },
    { "MUS_E2M6", 0 },
    { "MUS_E2M7", 0 },
    { "MUS_E2M8", 0 },
    { "MUS_E2M9", 0 },

    { "MUS_E1M1", 0 }, // 3-1
    { "MUS_E3M2", 0 },
    { "MUS_E3M3", 0 },
    { "MUS_E1M6", 0 },
    { "MUS_E1M3", 0 },
    { "MUS_E1M2", 0 },
    { "MUS_E1M5", 0 },
    { "MUS_E1M9", 0 },
    { "MUS_E2M6", 0 },

    { "MUS_E1M6", 0 }, // 4-1
    { "MUS_E1M2", 0 },
    { "MUS_E1M3", 0 },
    { "MUS_E1M4", 0 },
    { "MUS_E1M5", 0 },
    { "MUS_E1M1", 0 },
    { "MUS_E1M7", 0 },
    { "MUS_E1M8", 0 },
    { "MUS_E1M9", 0 },

    { "MUS_E2M1", 0 }, // 5-1
    { "MUS_E2M2", 0 },
    { "MUS_E2M3", 0 },
    { "MUS_E2M4", 0 },
    { "MUS_E1M4", 0 },
    { "MUS_E2M6", 0 },
    { "MUS_E2M7", 0 },
    { "MUS_E2M8", 0 },
    { "MUS_E2M9", 0 },

    { "MUS_E3M2", 0 }, // 6-1
    { "MUS_E3M3", 0 },
    { "MUS_E1M6", 0 },

    { "MUS_TITL", 0 },
    { "MUS_INTR", 0 },
    { "MUS_CPTD", 0 },

    { 0 } // for S_music[mus_musinfo].lumpnum = -1; ?
};

sfxinfo_t heretic_S_sfx[] = {
    { "", 0, 0, -1, -1, 0, 0, 0, "" },
    { "gldhit", 32, 0, -1, -1, 0, 0, 2, "" },
    { "gntful", 32, 0, -1, -1, 0, 0, -1, "" },
    { "gnthit", 32, 0, -1, -1, 0, 0, -1, "" },
    { "gntpow", 32, 0, -1, -1, 0, 0, -1, "" },
    { "gntact", 32, 0, -1, -1, 0, 0, -1, "" },
    { "gntuse", 32, 0, -1, -1, 0, 0, -1, "" },
    { "phosht", 32, 0, -1, -1, 0, 0, 2, "" },
    { "phohit", 32, 0, -1, -1, 0, 0, -1, "" },
    { "-phopow", 32, &heretic_S_sfx[heretic_sfx_hedat1], 0, 0, 0, 0, 1, "", SFXF_OLDLINK },
    { "lobsht", 20, 0, -1, -1, 0, 0, 2, "" },
    { "lobhit", 20, 0, -1, -1, 0, 0, 2, "" },
    { "lobpow", 20, 0, -1, -1, 0, 0, 2, "" },
    { "hrnsht", 32, 0, -1, -1, 0, 0, 2, "" },
    { "hrnhit", 32, 0, -1, -1, 0, 0, 2, "" },
    { "hrnpow", 32, 0, -1, -1, 0, 0, 2, "" },
    { "ramphit", 32, 0, -1, -1, 0, 0, 2, "" },
    { "ramrain", 10, 0, -1, -1, 0, 0, 2, "" },
    { "bowsht", 32, 0, -1, -1, 0, 0, 2, "" },
    { "stfhit", 32, 0, -1, -1, 0, 0, 2, "" },
    { "stfpow", 32, 0, -1, -1, 0, 0, 2, "" },
    { "stfcrk", 32, 0, -1, -1, 0, 0, 2, "" },
    { "impsit", 32, 0, -1, -1, 0, 0, 2, "" },
    { "impat1", 32, 0, -1, -1, 0, 0, 2, "" },
    { "impat2", 32, 0, -1, -1, 0, 0, 2, "" },
    { "impdth", 80, 0, -1, -1, 0, 0, 2, "" },
    { "-impact", 20, &heretic_S_sfx[heretic_sfx_impsit], 0, 0, 0, 0, 2, "", SFXF_OLDLINK },
    { "imppai", 32, 0, -1, -1, 0, 0, 2, "" },
    { "mumsit", 32, 0, -1, -1, 0, 0, 2, "" },
    { "mumat1", 32, 0, -1, -1, 0, 0, 2, "" },
    { "mumat2", 32, 0, -1, -1, 0, 0, 2, "" },
    { "mumdth", 80, 0, -1, -1, 0, 0, 2, "" },
    { "-mumact", 20, &heretic_S_sfx[heretic_sfx_mumsit], 0, 0, 0, 0, 2, "", SFXF_OLDLINK },
    { "mumpai", 32, 0, -1, -1, 0, 0, 2, "" },
    { "mumhed", 32, 0, -1, -1, 0, 0, 2, "" },
    { "bstsit", 32, 0, -1, -1, 0, 0, 2, "" },
    { "bstatk", 32, 0, -1, -1, 0, 0, 2, "" },
    { "bstdth", 80, 0, -1, -1, 0, 0, 2, "" },
    { "bstact", 20, 0, -1, -1, 0, 0, 2, "" },
    { "bstpai", 32, 0, -1, -1, 0, 0, 2, "" },
    { "clksit", 32, 0, -1, -1, 0, 0, 2, "" },
    { "clkatk", 32, 0, -1, -1, 0, 0, 2, "" },
    { "clkdth", 80, 0, -1, -1, 0, 0, 2, "" },
    { "clkact", 20, 0, -1, -1, 0, 0, 2, "" },
    { "clkpai", 32, 0, -1, -1, 0, 0, 2, "" },
    { "snksit", 32, 0, -1, -1, 0, 0, 2, "" },
    { "snkatk", 32, 0, -1, -1, 0, 0, 2, "" },
    { "snkdth", 80, 0, -1, -1, 0, 0, 2, "" },
    { "snkact", 20, 0, -1, -1, 0, 0, 2, "" },
    { "snkpai", 32, 0, -1, -1, 0, 0, 2, "" },
    { "kgtsit", 32, 0, -1, -1, 0, 0, 2, "" },
    { "kgtatk", 32, 0, -1, -1, 0, 0, 2, "" },
    { "kgtat2", 32, 0, -1, -1, 0, 0, 2, "" },
    { "kgtdth", 80, 0, -1, -1, 0, 0, 2, "" },
    { "-kgtact", 20, &heretic_S_sfx[heretic_sfx_kgtsit], 0, 0, 0, 0, 2, "", SFXF_OLDLINK },
    { "kgtpai", 32, 0, -1, -1, 0, 0, 2, "" },
    { "wizsit", 32, 0, -1, -1, 0, 0, 2, "" },
    { "wizatk", 32, 0, -1, -1, 0, 0, 2, "" },
    { "wizdth", 80, 0, -1, -1, 0, 0, 2, "" },
    { "wizact", 20, 0, -1, -1, 0, 0, 2, "" },
    { "wizpai", 32, 0, -1, -1, 0, 0, 2, "" },
    { "minsit", 32, 0, -1, -1, 0, 0, 2, "" },
    { "minat1", 32, 0, -1, -1, 0, 0, 2, "" },
    { "minat2", 32, 0, -1, -1, 0, 0, 2, "" },
    { "minat3", 32, 0, -1, -1, 0, 0, 2, "" },
    { "mindth", 80, 0, -1, -1, 0, 0, 2, "" },
    { "minact", 20, 0, -1, -1, 0, 0, 2, "" },
    { "minpai", 32, 0, -1, -1, 0, 0, 2, "" },
    { "hedsit", 32, 0, -1, -1, 0, 0, 2, "" },
    { "hedat1", 32, 0, -1, -1, 0, 0, 2, "" },
    { "hedat2", 32, 0, -1, -1, 0, 0, 2, "" },
    { "hedat3", 32, 0, -1, -1, 0, 0, 2, "" },
    { "heddth", 80, 0, -1, -1, 0, 0, 2, "" },
    { "hedact", 20, 0, -1, -1, 0, 0, 2, "" },
    { "hedpai", 32, 0, -1, -1, 0, 0, 2, "" },
    { "sorzap", 32, 0, -1, -1, 0, 0, 2, "" },
    { "sorrise", 32, 0, -1, -1, 0, 0, 2, "" },
    { "sorsit", 200, 0, -1, -1, 0, 0, 2, "" },
    { "soratk", 32, 0, -1, -1, 0, 0, 2, "" },
    { "soract", 200, 0, -1, -1, 0, 0, 2, "" },
    { "sorpai", 200, 0, -1, -1, 0, 0, 2, "" },
    { "sordsph", 200, 0, -1, -1, 0, 0, 2, "" },
    { "sordexp", 200, 0, -1, -1, 0, 0, 2, "" },
    { "sordbon", 200, 0, -1, -1, 0, 0, 2, "" },
    { "-sbtsit", 32, &heretic_S_sfx[heretic_sfx_bstsit], 0, 0, 0, 0, 2, "", SFXF_OLDLINK },
    { "-sbtatk", 32, &heretic_S_sfx[heretic_sfx_bstatk], 0, 0, 0, 0, 2, "", SFXF_OLDLINK },
    { "sbtdth", 80, 0, -1, -1, 0, 0, 2, "" },
    { "sbtact", 20, 0, -1, -1, 0, 0, 2, "" },
    { "sbtpai", 32, 0, -1, -1, 0, 0, 2, "" },
    { "plroof", 32, 0, -1, -1, 0, 0, 2, "" },
    { "plrpai", 32, 0, -1, -1, 0, 0, 2, "" },
    { "plrdth", 80, 0, -1, -1, 0, 0, 2, "" },
    { "gibdth", 100, 0, -1, -1, 0, 0, 2, "" },
    { "plrwdth", 80, 0, -1, -1, 0, 0, 2, "" },
    { "plrcdth", 100, 0, -1, -1, 0, 0, 2, "" },
    { "itemup", 32, 0, -1, -1, 0, 0, 2, "" },
    { "wpnup", 32, 0, -1, -1, 0, 0, 2, "" },
    { "telept", 50, 0, -1, -1, 0, 0, 2, "" },
    { "doropn", 40, 0, -1, -1, 0, 0, 2, "" },
    { "dorcls", 40, 0, -1, -1, 0, 0, 2, "" },
    { "dormov", 40, 0, -1, -1, 0, 0, 2, "" },
    { "artiup", 32, 0, -1, -1, 0, 0, 2, "" },
    { "switch", 40, 0, -1, -1, 0, 0, 2, "" },
    { "pstart", 40, 0, -1, -1, 0, 0, 2, "" },
    { "pstop", 40, 0, -1, -1, 0, 0, 2, "" },
    { "stnmov", 40, 0, -1, -1, 0, 0, 2, "" },
    { "chicpai", 32, 0, -1, -1, 0, 0, 2, "" },
    { "chicatk", 32, 0, -1, -1, 0, 0, 2, "" },
    { "chicdth", 40, 0, -1, -1, 0, 0, 2, "" },
    { "chicact", 32, 0, -1, -1, 0, 0, 2, "" },
    { "chicpk1", 32, 0, -1, -1, 0, 0, 2, "" },
    { "chicpk2", 32, 0, -1, -1, 0, 0, 2, "" },
    { "chicpk3", 32, 0, -1, -1, 0, 0, 2, "" },
    { "keyup", 50, 0, -1, -1, 0, 0, 2, "" },
    { "ripslop", 16, 0, -1, -1, 0, 0, 2, "" },
    { "newpod", 16, 0, -1, -1, 0, 0, -1, "" },
    { "podexp", 40, 0, -1, -1, 0, 0, -1, "" },
    { "bounce", 16, 0, -1, -1, 0, 0, 2, "" },
    { "-volsht", 16, &heretic_S_sfx[heretic_sfx_bstatk], 0, 0, 0, 0, 2, "", SFXF_OLDLINK },
    { "-volhit", 16, &heretic_S_sfx[heretic_sfx_lobhit], 0, 0, 0, 0, 2, "", SFXF_OLDLINK },
    { "burn", 10, 0, -1, -1, 0, 0, 2, "" },
    { "splash", 10, 0, -1, -1, 0, 0, 1, "" },
    { "gloop", 10, 0, -1, -1, 0, 0, 2, "" },
    { "respawn", 10, 0, -1, -1, 0, 0, 1, "" },
    { "blssht", 32, 0, -1, -1, 0, 0, 2, "" },
    { "blshit", 32, 0, -1, -1, 0, 0, 2, "" },
    { "chat", 100, 0, -1, -1, 0, 0, 1, "" },
    { "artiuse", 32, 0, -1, -1, 0, 0, 1, "" },
    { "gfrag", 100, 0, -1, -1, 0, 0, 1, "" },
    { "waterfl", 16, 0, -1, -1, 0, 0, 2, "" },

    // Monophonic sounds

    { "wind", 16, 0, -1, -1, 0, 0, 1, "" },
    { "amb1", 1, 0, -1, -1, 0, 0, 1, "" },
    { "amb2", 1, 0, -1, -1, 0, 0, 1, "" },
    { "amb3", 1, 0, -1, -1, 0, 0, 1, "" },
    { "amb4", 1, 0, -1, -1, 0, 0, 1, "" },
    { "amb5", 1, 0, -1, -1, 0, 0, 1, "" },
    { "amb6", 1, 0, -1, -1, 0, 0, 1, "" },
    { "amb7", 1, 0, -1, -1, 0, 0, 1, "" },
    { "amb8", 1, 0, -1, -1, 0, 0, 1, "" },
    { "amb9", 1, 0, -1, -1, 0, 0, 1, "" },
    { "amb10", 1, 0, -1, -1, 0, 0, 1, "" },
    { "amb11", 1, 0, -1, -1, 0, 0, 0, "" },
};
